/* -*- indent-tabs-mode: t; tab-width: 8; c-basic-offset: 8; -*- */

#include <unistd.h>
#include <assert.h>
#include <stdio.h>
#include <signal.h>
#include "init.h"
#include "sg.h"
#include "error.h"
#include "libburn.h"
#include "drive.h"

int burn_running = 0;

/* ts A60813 : wether to use O_EXCL and/or O_NONBLOCK in libburn/sg.c */
int burn_sg_open_o_excl = 1;

/* O_NONBLOCK was hardcoded in enumerate_ata() which i hardly use.
   For enumerate_sg() it seems ok.
   So it should stay default mode until enumerate_ata() without O_NONBLOCK
   has been thoroughly tested. */
int burn_sg_open_o_nonblock = 1;

/* wether to take a busy drive as an error */
/* Caution: this is implemented by a rough hack and eventually leads
	    to unconditional abort of the process  */
int burn_sg_open_abort_busy = 0;


int burn_initialize(void)
{
	if (burn_running)
		return 1;

	burn_running = 1;
	return 1;
}

void burn_finish(void)
{
	assert(burn_running);

	burn_wait_all();

	burn_drive_free();

	burn_running = 0;
}


void burn_preset_device_open(int exclusive, int blocking, int abort_on_busy)
{
	assert(burn_running);

	burn_sg_open_o_excl= !!exclusive;
	burn_sg_open_o_nonblock= !blocking;
	burn_sg_open_abort_busy= !!abort_on_busy;
}

